pub mod models;

pub use models::*;

pub enum AuthErr {
    UnknownSession,
    UnknownUser,
    InvalidPassword,
    Other(Box<dyn std::error::Error>),
}

pub trait AuthRepository: Send + Sync {
    /// Validate the given session ID and return its user.
    fn validate_session(&self, session_id: i64) -> Result<models::User, AuthErr>;

    /// Create a new session for the given user.
    fn create_session(
        &self,
        username: &str,
        password: &str,
    ) -> Result<(i64, models::User), AuthErr>;
}

// pub trait DeviceRepository: Send + Sync {
//     fn devices_for_user(&self, )
// }
