mod error;
mod gpodder;

use axum::Router;
use tower_http::trace::TraceLayer;

#[derive(Clone)]
pub struct Context {
    pub pool: crate::db::DbPool,
    pub repo: crate::db::SqliteRepository,
}

pub fn app(ctx: Context) -> Router {
    Router::new()
        .merge(gpodder::router(ctx.clone()))
        .layer(TraceLayer::new_for_http())
        .with_state(ctx)
}
